﻿// © Copyright 2011 Agilent Technologies, Inc.

using System;
using System.Text;

namespace Agilent.Vee.EvoExample
{
    /// <summary>
    /// Helper to construct and split graph object data.
    /// </summary>
    internal class DataState
    {
        private String m_y;
        private Double m_xFrom;
        private Double m_xTo;
        private Int32 m_size;
        private Boolean m_yTermAdded;
        private Boolean m_xTermAdded;
        private Boolean m_sizeTermAdded;

        #region Properties

        internal String YExpression
        {
            get
            {
                return m_y;
            }
            set
            {
                m_y = value;
            }
        }

        internal Double XFrom
        {
            get
            {
                return m_xFrom;
            }
            set
            {
                m_xFrom = value;
            }
        }

        internal Double XTo
        {
            get
            {
                return m_xTo;
            }
            set
            {
                m_xTo = value;
            }
        }

        internal Int32 DataSize
        {
            get
            {
                return m_size;
            }
            set
            {
                m_size = value;
            }
        }

        internal Boolean YTermAdded
        {
            get
            {
                return m_yTermAdded;
            }
            set
            {
                m_yTermAdded = value;
            }
        }

        internal Boolean XTermAdded
        {
            get
            {
                return m_xTermAdded;
            }
            set
            {
                m_xTermAdded = value;
            }
        }

        internal Boolean SizeTermAdded
        {
            get
            {
                return m_sizeTermAdded;
            }
            set
            {
                m_sizeTermAdded = value;
            }
        }

        #endregion // Properties

        internal String ConstructState()
        {
            StringBuilder state = new StringBuilder(200);
            AppendState(m_y, state);
            AppendState(m_xFrom, state);
            AppendState(m_xTo, state);
            AppendState(m_size, state);
            AppendState(m_yTermAdded, state);
            AppendState(m_xTermAdded, state);
            AppendLastState(m_sizeTermAdded, state);

            return state.ToString();
        }

        internal void SplitState(String state, out Boolean updated)
        {
            String[] data = state.Split('|');
            if (data.Length == 7)
            {
                m_y = data[0];
                m_xFrom = Convert.ToDouble(data[1]);
                m_xTo = Convert.ToDouble(data[2]);
                m_size = Convert.ToInt32(data[3]);
                m_yTermAdded = Convert.ToBoolean(data[4]);
                m_xTermAdded = Convert.ToBoolean(data[5]);
                m_sizeTermAdded = Convert.ToBoolean(data[6]);
                updated = true;
            }
            else
            {
                updated = false;
            }
        }

        private void AppendState(object data, StringBuilder state)
        {
            state.Append(data.ToString());
            state.Append("|");
        }

        private void AppendLastState(object data, StringBuilder state)
        {
            state.Append(data.ToString());
        }

    }
}
