// $ANTLR 2.7.7 (20060906): "Expression.g" -> "Lexer.cs"$

using System.IO;

namespace Agilent.Vee.EvoExample.ExpressionGraph
{
	// Generate header specific to lexer CSharp file
	using System;
	using Stream                          = System.IO.Stream;
	using TextReader                      = System.IO.TextReader;
	using Hashtable                       = System.Collections.Hashtable;
	using Comparer                        = System.Collections.Comparer;
	
	using TokenStreamException            = antlr.TokenStreamException;
	using TokenStreamIOException          = antlr.TokenStreamIOException;
	using TokenStreamRecognitionException = antlr.TokenStreamRecognitionException;
	using CharStreamException             = antlr.CharStreamException;
	using CharStreamIOException           = antlr.CharStreamIOException;
	using ANTLRException                  = antlr.ANTLRException;
	using CharScanner                     = antlr.CharScanner;
	using InputBuffer                     = antlr.InputBuffer;
	using ByteBuffer                      = antlr.ByteBuffer;
	using CharBuffer                      = antlr.CharBuffer;
	using Token                           = antlr.Token;
	using IToken                          = antlr.IToken;
	using CommonToken                     = antlr.CommonToken;
	using SemanticException               = antlr.SemanticException;
	using RecognitionException            = antlr.RecognitionException;
	using NoViableAltForCharException     = antlr.NoViableAltForCharException;
	using MismatchedCharException         = antlr.MismatchedCharException;
	using TokenStream                     = antlr.TokenStream;
	using LexerSharedInputState           = antlr.LexerSharedInputState;
	using BitSet                          = antlr.collections.impl.BitSet;
	
	public 	class Lexer : antlr.CharScanner	, TokenStream
	 {
		public const Int32 EOF = 1;
		public const Int32 NULL_TREE_LOOKAHEAD = 3;
		public const Int32 SIGN_MINUS = 4;
		public const Int32 SIGN_PLUS = 5;
		public const Int32 LPAREN = 6;
		public const Int32 RPAREN = 7;
		public const Int32 PLUS = 8;
		public const Int32 MINUS = 9;
		public const Int32 MUL = 10;
		public const Int32 DIV = 11;
		public const Int32 POW = 12;
		public const Int32 ABS = 13;
		public const Int32 ACOS = 14;
		public const Int32 ASIN = 15;
		public const Int32 ATAN = 16;
		public const Int32 COS = 17;
		public const Int32 EXP = 18;
		public const Int32 LOG = 19;
		public const Int32 LOG10 = 20;
		public const Int32 SQRT = 21;
		public const Int32 SIN = 22;
		public const Int32 TAN = 23;
		public const Int32 NUMBER = 24;
		public const Int32 X = 25;
		public const Int32 WS = 26;
		
		public Lexer(Stream ins) : this(new ByteBuffer(ins))
		{
		}
		
		public Lexer(TextReader r) : this(new CharBuffer(r))
		{
		}
		
		public Lexer(InputBuffer ib)		 : this(new LexerSharedInputState(ib))
		{
		}
		
		public Lexer(LexerSharedInputState state) : base(state)
		{
			initialize();
		}
		private void initialize()
		{
			caseSensitiveLiterals = true;
			setCaseSensitive(false);
			//literals = new Hashtable(100, (float) 0.4, null, Comparer.Default); obsolete
            literals = new Hashtable(100, (float)0.4, null);
		}
		
		override public IToken nextToken()			//throws TokenStreamException
		{
			IToken theRetToken = null;
tryAgain:
			for (;;)
			{
				//IToken _token = null;
				Int32 _ttype = Token.INVALID_TYPE;
				resetText();
				try     // for char stream error handling
				{
					try     // for lexical error handling
					{
						switch ( cached_LA1 )
						{
						case '\t':  case '\n':  case '\r':  case ' ':
						{
							mWS(true);
							theRetToken = returnToken_;
							break;
						}
						case '0':  case '1':  case '2':  case '3':
						case '4':  case '5':  case '6':  case '7':
						case '8':  case '9':
						{
							mNUMBER(true);
							theRetToken = returnToken_;
							break;
						}
						case 'x':
						{
							mX(true);
							theRetToken = returnToken_;
							break;
						}
						case 'c':
						{
							mCOS(true);
							theRetToken = returnToken_;
							break;
						}
						case 'e':
						{
							mEXP(true);
							theRetToken = returnToken_;
							break;
						}
						case 't':
						{
							mTAN(true);
							theRetToken = returnToken_;
							break;
						}
						case '+':
						{
							mPLUS(true);
							theRetToken = returnToken_;
							break;
						}
						case '-':
						{
							mMINUS(true);
							theRetToken = returnToken_;
							break;
						}
						case '*':
						{
							mMUL(true);
							theRetToken = returnToken_;
							break;
						}
						case '/':
						{
							mDIV(true);
							theRetToken = returnToken_;
							break;
						}
						case '^':
						{
							mPOW(true);
							theRetToken = returnToken_;
							break;
						}
						case '(':
						{
							mLPAREN(true);
							theRetToken = returnToken_;
							break;
						}
						case ')':
						{
							mRPAREN(true);
							theRetToken = returnToken_;
							break;
						}
						default:
							if ((cached_LA1=='l') && (cached_LA2=='o') && (LA(3)=='g') && (LA(4)=='1'))
							{
								mLOG10(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='l') && (cached_LA2=='o') && (LA(3)=='g') && (true)) {
								mLOG(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='a') && (cached_LA2=='b')) {
								mABS(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='a') && (cached_LA2=='c')) {
								mACOS(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='a') && (cached_LA2=='s')) {
								mASIN(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='a') && (cached_LA2=='t')) {
								mATAN(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='s') && (cached_LA2=='q')) {
								mSQRT(true);
								theRetToken = returnToken_;
							}
							else if ((cached_LA1=='s') && (cached_LA2=='i')) {
								mSIN(true);
								theRetToken = returnToken_;
							}
						else
						{
							if (cached_LA1==EOF_CHAR) { uponEOF(); returnToken_ = makeToken(Token.EOF_TYPE); }
				else {throw new NoViableAltForCharException(cached_LA1, getFilename(), getLine(), getColumn());}
						}
						break; }
						if ( null==returnToken_ ) goto tryAgain; // found SKIP token
						_ttype = returnToken_.Type;
						_ttype = testLiteralsTable(_ttype);
						returnToken_.Type = _ttype;
						return returnToken_;
					}
					catch (RecognitionException e) {
							throw new TokenStreamRecognitionException(e);
					}
				}
				catch (CharStreamException cse) {
					if ( cse is CharStreamIOException ) {
						throw new TokenStreamIOException(((CharStreamIOException)cse).io);
					}
					else {
						throw new TokenStreamException(cse.Message);
					}
				}
			}
		}
		
	public void mWS(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = WS;
		
		{ // ( ... )+
			Int32 _cnt22=0;
			for (;;)
			{
				switch ( cached_LA1 )
				{
				case ' ':
				{
					match(' ');
					break;
				}
				case '\t':
				{
					match('\t');
					break;
				}
				case '\n':
				{
					match('\n');
					break;
				}
				case '\r':
				{
					match('\r');
					break;
				}
				default:
				{
					if (_cnt22 >= 1) { goto _loop22_breakloop; } else { throw new NoViableAltForCharException(cached_LA1, getFilename(), getLine(), getColumn());; }
				}
				//break; 
                }
				_cnt22++;
			}
_loop22_breakloop:			;
		}    // ( ... )+
		
			_ttype = Token.SKIP;
		
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mNUMBER(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = NUMBER;
		
		{ // ( ... )+
			Int32 _cnt25=0;
			for (;;)
			{
				if (((cached_LA1 >= '0' && cached_LA1 <= '9')))
				{
					matchRange('0','9');
				}
				else
				{
					if (_cnt25 >= 1) { goto _loop25_breakloop; } else { throw new NoViableAltForCharException(cached_LA1, getFilename(), getLine(), getColumn());; }
				}
				
				_cnt25++;
			}
_loop25_breakloop:			;
		}    // ( ... )+
		{
			if ((cached_LA1=='.'))
			{
				match('.');
				{    // ( ... )*
					for (;;)
					{
						if (((cached_LA1 >= '0' && cached_LA1 <= '9')))
						{
							matchRange('0','9');
						}
						else
						{
							goto _loop28_breakloop;
						}
						
					}
_loop28_breakloop:					;
				}    // ( ... )*
			}
			else {
			}
			
		}
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mX(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = X;
		
		match("x");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mABS(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = ABS;
		
		match("abs");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mACOS(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = ACOS;
		
		match("acos");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mASIN(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = ASIN;
		
		match("asin");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mATAN(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = ATAN;
		
		match("atan ");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mCOS(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = COS;
		
		match("cos");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mEXP(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = EXP;
		
		match("exp");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mLOG(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = LOG;
		
		match("log");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mLOG10(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = LOG10;
		
		match("log10");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mSQRT(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = SQRT;
		
		match("sqrt");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mSIN(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = SIN;
		
		match("sin");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mTAN(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = TAN;
		
		match("tan");
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mPLUS(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = PLUS;
		
		match('+');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mMINUS(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = MINUS;
		
		match('-');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mMUL(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = MUL;
		
		match('*');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mDIV(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = DIV;
		
		match('/');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mPOW(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = POW;
		
		match('^');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mLPAREN(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = LPAREN;
		
		match('(');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	public void mRPAREN(bool _createToken) //throws RecognitionException, CharStreamException, TokenStreamException
{
		Int32 _ttype; IToken _token=null; Int32 _begin=text.Length;
		_ttype = RPAREN;
		
		match(')');
		if (_createToken && (null == _token) && (_ttype != Token.SKIP))
		{
			_token = makeToken(_ttype);
			_token.setText(text.ToString(_begin, text.Length-_begin));
		}
		returnToken_ = _token;
	}
	
	
	
}
}
